unit CustomUnit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Spin, Math, Menus, ComCtrls;

type
  TMainForm = class(TForm)
    Image1: TImage;
    FilterList: TListBox;
    LoadFileBtn: TButton;
    FHist: TListBox;
    ResetBtn: TButton;
    UseFilterBtn: TButton;
    FilterTimes: TSpinEdit;
    GFXOpenDialog: TOpenDialog;
    ClearHistBtn: TButton;
    TitleBar: TImage;
    Label2: TLabel;
    MiniImg: TImage;
    CloseImg: TImage;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    Script: TListBox;
    RunScriptBtn: TButton;
    LoadScriptBtn: TButton;
    SaveScriptBtn: TButton;
    EraseScriptbtn: TButton;
    ScriptReset: TCheckBox;
    ScriptOpenDialog: TOpenDialog;
    SaveScriptDialog: TSaveDialog;
    Timer1: TTimer;
    ClrScriptBtn: TButton;
    TreeView1: TTreeView;
    LoadedName: TStaticText;
    TitleImg: TImage;
    TitlePopup: TPopupMenu;
    Minimieren1: TMenuItem;
    N1: TMenuItem;
    Close1: TMenuItem;
    About1: TMenuItem;
    PasteImg: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure LoadFileBtnClick(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
    procedure UseFilterBtnClick(Sender: TObject);
    procedure FilterListClick(Sender: TObject);
    procedure ClearHistBtnClick(Sender: TObject);
    procedure MiniImgClick(Sender: TObject);
    procedure CloseImgClick(Sender: TObject);
    procedure FilterListDblClick(Sender: TObject);
    procedure EraseScriptbtnClick(Sender: TObject);
    procedure RunScriptBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure LoadScriptBtnClick(Sender: TObject);
    procedure SaveScriptBtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ClrScriptBtnClick(Sender: TObject);
    procedure TreeView1DblClick(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TreeView1Click(Sender: TObject);
    procedure TitleImgClick(Sender: TObject);
    procedure TitleImgDblClick(Sender: TObject);
    procedure Minimieren1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    Procedure Perform_Calc;
    procedure Single_Filter;
    Procedure Script_Filter;
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    Procedure WMNCHitTest(Var Message : TWMNCHitTest); Message WM_NCHITTEST;
  end;

  TCalcType = (CT_SINGLE,CT_SCRIPT);

Const WinDX = 320;
      WinDY = 240;

      HistDX = 256;
      HistDY = 200;

      ST_NORMAL = 1;
      ST_AND    = 2;
      ST_OR     = 3;
      ST_XOR    = 4;

Type TBuffer = Array[0..WinDY-1,0..WinDX-1] Of Word;
     THisto  = Array[0..HistDY-1,0..HistDX-1] Of Word;

Const Blur      = 0000;
      LapLace   = 0001;
      HExtract  = 0002;
      VExtract  = 0003;
      HAndVEx   = 0004;
      Lighten   = 0005;
      Darken    = 0006;
      MyKante   = 0007;
      TomAlg    = 0008;
      GradientH = 0009;
      GradientV = 0010;
      GradientM = 0011;
      ReliefH   = 0012;
      ReliefV   = 0013;
      ReliefM   = 0014;
      FaltenH   = 0015;
      FaltenV   = 0016;
      FaltenM   = 0017;
      FaltenMed1= 0018;
      FaltenMed2= 0019;
      FaltenMedM= 0020;
      Threshold = 0021;
      FaltenAll = 0022;
      Gauss     = 0023;
      SobelX    = 0024;
      SobelY    = 0025;
      SobelM    = 0026;
      KontrastP = 0027;
      Erosion   = 0028;
      Dilation  = 0029;
      ThresWin  = 0030;
      SobelA    = 0031;
      SemiKante = 0032;
      MarrHild  = 0033;
      GaussH    = 0034;
      GaussV    = 0035;
      Prewitt   = 0036;
      RGNGrow   = 0037;
      Hurst     = 0038;

      RelDist = 1;

      HRes = 320;
      VRes = 200;

var
  MainForm  : TMainForm;
  MainHDC   : HDC;
  MainBuf   : TBuffer;
  MainHist  : THisto;
  BmpInfo   : TBitmapInfo;
  HistInfo  : TBitmapInfo;
  GrayPal   : Array[0..255] Of Word;
  Pic       : Array[0..VRes-1,0..HRes-1] Of Byte;
  CalcPic   : Array[0..VRes-1,0..HRes-1] Of Byte;
  BackUp    : Array[0..VRes-1,0..HRes-1] Of Byte;
  Histo     : Array[0..255] Of LongInt;
  HistCount : LongInt;
  GLoaded   : Boolean;
  Calced    : Boolean;
  HistPix   : Word;
  TitleRect,CloseRect,MiniRect : TRect;

  DrawRect                     : TRect;
  MDown                        : Boolean;
  StartCapX,StartCapY          : Integer;
  EndCapX,EndCapY              : Integer;
  BrightRun                    : Boolean;

  CalcType                     : TCalcType;
  CalcPos                      : Integer;

  InCalc                       : Boolean;
  AbortIt                      : Boolean;

  SingleTHID,ScriptTHID        : DWord;

  ScriptList                   : Array[0..999] Of Word;
  ScriptCount                  : Word;

implementation

uses AboutUnit1, ProgressUnit1;

{$R *.DFM}

Function InRect(X,Y : Integer; R : TRect) : Boolean;
Begin
     InRect:=((X>=R.Left) And (X<=R.Right) And
             (Y>=R.Top) And (Y<=R.Bottom));
End;

Procedure TMainForm.WMNCHitTest(Var Message : TWMNCHitTest);
Var P : TPoint;
Begin
     Inherited;

     P.X:=Message.XPos;
     P.Y:=Message.YPos;

     P:=ScreenToClient(P);

     If InRect(P.X,P.Y,Rect(MiniImg.Left,MiniImg.Top,
                       MiniImg.Left+20,MiniImg.Top+20)) Or
        InRect(P.X,P.Y,Rect(CloseImg.Left,CloseImg.Top,
                       CloseImg.Left+20,CloseImg.Top+20)) Or
        InRect(P.X,P.Y,Rect(TitleImg.Left,TitleImg.Top,
                       TitleImg.Left+20,TitleImg.Top+20)) Then
        Message.Result:=HtClient
     Else
     If InRect(P.X,P.Y,TitleRect) Then
        Message.Result:=HtCaption;
End;

Procedure InitGraphic;
Var BiSize : Integer;
Begin
     // Main-Bitmap
     BiSize:=SizeOf(TBitmapInfoHeader);
     FillChar(BmpInfo.BmiHeader,BiSize,0);

     BmpInfo.BmiHeader.BiSize:=BiSize;
     BmpInfo.BmiHeader.BiWidth:=WinDX;
     BmpInfo.BmiHeader.BiHeight:=-WinDY;
     BmpInfo.BmiHeader.BiPlanes:=1;
     BmpInfo.BmiHeader.BiBitCount:=16;
     BmpInfo.BmiHeader.BiCompression:=BI_RGB;

     // History-Bitmap
     BiSize:=SizeOf(TBitmapInfoHeader);
     FillChar(HistInfo.BmiHeader,BiSize,0);

     HistInfo.BmiHeader.BiSize:=BiSize;
     HistInfo.BmiHeader.BiWidth:=HistDX;
     HistInfo.BmiHeader.BiHeight:=-HistDY;
     HistInfo.BmiHeader.BiPlanes:=1;
     HistInfo.BmiHeader.BiBitCount:=16;
     HistInfo.BmiHeader.BiCompression:=BI_RGB;
End;

Function ColorCode(R,G,B : Word) : Word;
Begin
     Result:=B Or (G Shl 5) Or (R Shl 10);
End;

Procedure BlitItPic;
Begin
     SetDIBitsToDevice(MainHDC,23,50,WinDX,WinDY,
                       0,0,0,WinDY,@MainBuf,
                       BmpInfo,
                       DIB_RGB_COLORS);
End;

Procedure BlitItHist;
Begin
     SetDIBitsToDevice(MainHDC,361,50,HistDX,HistDY,
                       0,0,0,HistDY,@MainHist,
                       HistInfo,
                       DIB_RGB_COLORS);
End;

Procedure ClearMainPic;
Begin
     FillChar(MainBuf,SizeOf(MainBuf),0);
End;

Procedure ClearHistPic;
Var Clr,ZX,ZY : Word;
Begin
     Clr:=ColorCode(14,14,14);
     For ZY:=0 To HistDY-1 Do
         For ZX:=0 To HistDX-1 Do
             MainHist[ZY,ZX]:=Clr;
End;

Procedure LoadGrayPal;
Var D : File;
    Tmp : Array[0..255,1..3] Of Byte;
    Z   : Integer;
Begin
     AssignFile(D,'GRAY2.PAL'); Reset(D,1);
     BlockRead(D,Tmp,768);
     CloseFile(D);

     For Z:=0 To 255 Do
         GrayPal[Z]:=ColorCode(Tmp[Z,1] Shr 1,Tmp[Z,2] Shr 1,Tmp[Z,3] Shr 1);
End;

procedure TMainForm.FormCreate(Sender: TObject);
begin
     MainHDC:=GetDC(MainForm.Handle);
     InitGraphic;

     ClearMainPic;
     ClearHistPic;

     LoadGrayPal;

     HistPix:=ColorCode(2,4,6);

     With TitleBar Do
          TitleRect:=Rect(Left,Top,
                          Left+Width,Top+Height);

     DrawRect:=Rect(23,50,23+WinDX,50+WinDY);

     ScriptCount:=0;
     MDown:=False;
     BrightRun:=False;

     InCalc:=False;
end;

Procedure SwitchBrightPic;
Begin
     MainForm.PasteImg.Visible:=BrightRun;
End;

procedure TMainForm.FormPaint(Sender: TObject);
begin
     BlitItPic;
     BlitItHist;
end;

Function Upper(S : String) : String;
Var T : String;
    Z : Integer;
Begin
     T:='';
     For Z:=1 To Length(S) Do
         T:=T+UpCase(S[Z]);
     Result:=T;
End;

Procedure Import_Log;
Var D : Text;
    ZX,ZY,C : Integer;
    Line  : String;
    AX,AY : Integer;
Begin
     AssignFile(D,MainForm.GFXOpenDialog.FileName); {$I-} Reset(D); {$I+}
     If IOResult<>0 Then
     Begin
          MessageDlg('Error occured - open',MtWarning,[MbOK],0);
          GLoaded:=False;
          Exit;
     End;
     Line:='';

     FillChar(Pic,SizeOf(Pic),0);

     For ZY:=0 To 59 Do
     Begin
          ReadLn(D,Line);
          If Length(Line)<79 Then
             ReadLn(D,Line);
          For ZX:=0 To 79 Do
          Begin
               C:=255-((Ord(Line[ZX+1])-64)*4);

               Pic[ZY,ZX]:=C;

               {
               For AX:=0 To 3 Do
                   For AY:=0 To 3 Do
                       Pic[ZY*4+AY,ZX*4+AX]:=C;
               }
               {
               Pic[ZY*2,ZX*2]:=C;
               Pic[ZY*2+1,ZX*2]:=C;
               Pic[ZY*2,ZX*2+1]:=C;
               Pic[ZY*2+1,ZX*2+1]:=C;
               }
          End;
     End;

     CloseFile(D);
     GLoaded:=True;
End;

Procedure Load_Grafix;
Var D : File;
    PPM : Boolean;
    ZX,ZY : Integer;
Begin
     If Upper(Copy(MainForm.GFXOpenDialog.FileName,
              Length(MainForm.GFXOpenDialog.FileName)-2,
              3))='LOG' Then
     Begin
          Import_Log;
          //If Gloaded Then
          //   Status('File successfully loaded...');
          Exit;
     End;

     AssignFile(D,MainForm.GFXOpenDialog.FileName); {$I-} Reset(D,1); {$I+}
     If IOResult<>0 Then
     Begin
          MessageDlg('Error occured - open',MtWarning,[MbOK],0);
          GLoaded:=False;
          Exit;
     End;

     If Upper(Copy(MainForm.GFXOpenDialog.FileName,
              Length(MainForm.GFXOpenDialog.FileName)-2,
              3))='PPM' Then
        PPM:=True
     Else
        PPM:=False;

     If PPM Then
     Begin
          If FileSize(D)<76814 Then
          Begin
               MessageDlg('Incorrect file size'+#13+#10+
                          'File too small'+#13+#10+#13+#10+
                          'Size supported : 320*240+14 >= 76814 bytes',MtError,[MbOK],0);
               Exit;
          End;

          Seek(D,14);
     End;

     If FileSize(D)<64000 Then
     Begin
          MessageDlg('Incorrect file size'+#13+#10+
                     'File too small'+#13+#10+#13+#10+
                     'Size supported : 320*200 >= 64000 bytes',MtError,[MbOK],0);
          Exit;
     End;

     BlockRead(D,Pic,HRes*VRes);

     If PPM Then
        For ZY:=0 To VRes-1 Do
            For ZX:=0 To HRes-1 Do
                Pic[ZY,ZX]:=Pic[ZY,ZX]*4;

     CloseFile(D);
     GLoaded:=True;
End;

Procedure PutPixel(X,Y : LongInt; C : Byte);
Begin
     MainBuf[Y,X]:=GrayPal[C];
End;

Procedure Show_Histogramm;
Var ZX,ZY : Integer;
    Max : Word;
    Fac : Real;
    C   : Byte;
Begin
     ClearHistPic;
     FillChar(Histo,SizeOf(Histo),0);
     Max:=0;
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
         Begin
              C:=CalcPic[ZY,ZX];
              If C>0 Then
              Begin
                   Inc(Histo[C]);
                   If Histo[C]>Max Then
                      Max:=Histo[C];
              End;
         End;
     If Max<1 Then Max:=1;
     Fac:=199/Max;
     For ZX:=0 To 255 Do
     Begin
          If Histo[ZX]>0 Then
             For ZY:=199-Round(Fac*Histo[ZX]) To 199 Do
                 MainHist[ZY,ZX]:=HistPix;
     End;
End;

Procedure Draw_Pic(H : Boolean);
Var ZX,ZY : Integer;
    RGBVal : LongInt;
    C      : Integer;
Begin
     If H Then
        Show_Histogramm;
     ClearMainPic;
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             PutPixel(ZX,ZY,CalcPic[ZY,ZX]);
     BlitItPic;
     BlitItHist;
End;

Procedure Reset_Calc;
Begin
     Calced:=False;
     Move(Pic,CalcPic,SizeOf(Pic));
     MainForm.FHist.Items.Clear;
     HistCount:=0;
     Draw_Pic(True);
End;

Function CutToN(S : String; L : Integer) : String;
Var Tmp : String;
Begin
     If Length(S)>L Then
     Begin
          Tmp:=S;
          While ((Pos('\',Tmp)>0) And (Length(Tmp)>L)) Do
                Tmp:=Copy(Tmp,Pos('\',Tmp)+1,Length(Tmp)-Pos('\',Tmp));
          Result:='...\'+Tmp;
     End
     Else
         Result:=S;
End;

procedure TMainForm.LoadFileBtnClick(Sender: TObject);
begin
     If GFXOpenDialog.Execute Then
     Begin
          BrightRun:=False;
          SwitchBrightPic;
          //FileName.Text:=GFXOpenDialog.FileName;
          LoadedName.Caption:=CutToN(GFXOpenDialog.FileName,45);
          Load_Grafix;
          Reset_Calc;
          FHist.Items.Clear;
          HistCount:=0;
     End;
end;

procedure TMainForm.ResetBtnClick(Sender: TObject);
begin
     Reset_Calc;
     BrightRun:=False;
     SwitchBrightPic;
end;

Procedure Filter_Blur;
Var ZX,ZY : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              CalcPic[ZY,ZX]:=(BackUp[ZY-1,ZX]+BackUp[ZY+1,ZX]+
                               BackUp[ZY,ZX+1]+BackUp[ZY,ZX-1]) Div 4;
         End;
End;

Procedure Filter_Laplace;
Var ZX,ZY : Integer;
    Tmp   : LongInt;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              Tmp:=4*BackUp[ZY,ZX]-
                     BackUp[ZY-1,ZX+1]-
                     BackUp[ZY+1,ZX+1]-
                     BackUp[ZY+1,ZX]-
                     BackUp[ZY+1,ZX+2];
              Tmp:=Tmp Div 9;
              CalcPic[ZY,ZX]:=Tmp;
         End;
End;

Procedure Filter_HEx;
Var ZX,ZY : Integer;
    Tmp   : LongInt;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              Tmp:=2*BackUp[ZY,ZX+1]-
                   2*BackUp[ZY,ZX-1]+
                     BackUp[ZY-1,ZX+1]-
                     BackUp[ZY-1,ZX-1]+
                     BackUp[ZY+1,ZX+1]-
                     BackUp[ZY+1,ZX-1];
              Tmp:=Tmp Div 9;
              CalcPic[ZY,ZX]:=Tmp;
         End;
End;

Procedure Filter_VEx;
Var ZX,ZY : Integer;
    Tmp   : LongInt;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              Tmp:=2*BackUp[ZY+1,ZX]-
                   2*BackUp[ZY-1,ZX]+
                     BackUp[ZY+1,ZX-1]-
                     BackUp[ZY-1,ZX-1]+
                     BackUp[ZY+1,ZX+1]-
                     BackUp[ZY-1,ZX+1];
              Tmp:=Tmp Div 9;
              CalcPic[ZY,ZX]:=Tmp;
         End;
End;

Procedure Filter_HVEx;
Var ZX,ZY : Integer;
    Tmp   : LongInt;
    CPTmp : Array[0..VRes-1,0..HRes-1] Of Byte;
Begin
     // vertikale Extraktion
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              Tmp:=2*BackUp[ZY+1,ZX]-
                   2*BackUp[ZY-1,ZX]+
                     BackUp[ZY+1,ZX-1]-
                     BackUp[ZY-1,ZX-1]+
                     BackUp[ZY+1,ZX+1]-
                     BackUp[ZY-1,ZX+1];
              Tmp:=Tmp Div 9;
              CPTmp[ZY,ZX]:=Tmp;
         End;

     // horizontale Extraktion
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              Tmp:=2*BackUp[ZY,ZX+1]-
                   2*BackUp[ZY,ZX-1]+
                     BackUp[ZY-1,ZX+1]-
                     BackUp[ZY-1,ZX-1]+
                     BackUp[ZY+1,ZX+1]-
                     BackUp[ZY+1,ZX-1];
              Tmp:=Tmp Div 9;
              CalcPic[ZY,ZX]:=(Tmp+CpTmp[ZY,ZX])Div 2;
         End;
End;

Procedure Filter_Light;
Var ZX,ZY : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             If (CalcPic[ZY,ZX]<255) And (CalcPic[ZY,ZX]>0) Then
                CalcPic[ZY,ZX]:=CalcPic[ZY,ZX]+1;
End;

Procedure Filter_Dark;
Var ZX,ZY : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             If CalcPic[ZY,ZX]>0 Then
                CalcPic[ZY,ZX]:=CalcPic[ZY,ZX]-1;
End;

Procedure Filter_MyKante;
Var Z : Integer;
Begin
     Filter_HVEx;
     For Z:=1 To 5 Do
         Filter_Blur;
     For Z:=1 To 255 Do
         Filter_Light;
End;

Procedure Filter_TomAlg;
Var ZX,ZY : Integer;
    Z     : Word;
    ColAmount : Array[0..255] Of Word;
    Order     : Array[0..255] Of Byte;
    Max,Min   : Word;
    Ch        : Boolean;
    Tmp       : Integer;
Begin
     For Z:=0 To 255 Do
         Order[Z]:=Z;

     Max:=0; Min:=$FFFF;
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     FillChar(ColAmount,SizeOf(ColAmount),0);

     // Farben zhlen
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             Inc(ColAmount[CalcPic[ZY,ZX]]);

     Repeat
           Ch:=False;
           For Z:=0 To 255-1 Do
               If ColAmount[Order[Z]]>ColAmount[Order[Z+1]] Then
               Begin
                    Ch:=True;
                    Tmp:=Order[Z];
                    Order[Z]:=Order[Z+1];
                    Order[Z+1]:=Tmp;
               End;
     Until Not(Ch);

     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
         Begin
              CalcPic[ZY,ZX]:=Order[CalcPic[ZY,ZX]];
         End;

     // Minimumanzahl finden
     (*For Z:=0 To 255 Do
         If ColAmount[Z]<Min Then
            Min:=ColAmount[Z];

     // Minimumanzahl finden
     For Z:=0 To 255 Do
         If ColAmount[Z]>Max Then
            Max:=ColAmount[Z];

     // Filter anwenden
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
         Begin
              CalcPic[ZY,ZX]:=CalcPic[ZY,ZX]*Round(Max/ColAmount[CalcPic[ZY,ZX]]);
         End;
     *)
End;

Function Max(I : Integer) : Integer;
Begin
     If I>255 Then
        Result:=255
     Else
     If I<0 Then
        Result:=0
     Else
        Result:=I;
End;

Procedure Filter_GradientH;
Var ZX,ZY,Diff  : Integer;
    C1,C2,Delta : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-4 Do
         Begin
              C1:=CalcPic[ZY,ZX];
              C2:=CalcPic[ZY,ZX+3];
              Delta:=Abs(C1-C2);
              Diff:=Max(255-Delta);
              CalcPic[ZY,ZX]:=Diff;
         End;
End;

Procedure Filter_GradientV;
Var ZX,ZY,Diff  : Integer;
    C1,C2,Delta : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-1 Do
         Begin
              C1:=CalcPic[ZY,ZX];
              C2:=CalcPic[ZY+3,ZX];
              Delta:=Abs(C1-C2);
              Diff:=Max(255-Delta);
              CalcPic[ZY,ZX]:=Diff;
         End;
End;

Procedure Filter_GradientM;
Var ZX,ZY,Diff  : Integer;
    C1,C2,Delta : Integer;
    CPTmp : Array[0..VRes-1,0..HRes-1] Of Byte;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-4 Do
         Begin
              C1:=CalcPic[ZY,ZX];
              C2:=CalcPic[ZY,ZX+3];
              Delta:=Abs(C1-C2);
              Diff:=Max(255-Delta);
              CPTmp[ZY,ZX]:=Diff;
         End;

     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-1 Do
         Begin
              C1:=CalcPic[ZY,ZX];
              C2:=CalcPic[ZY+3,ZX];
              Delta:=Abs(C1-C2);
              Diff:=Max(255-Delta);
              CalcPic[ZY,ZX]:=Diff;
         End;

     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             If CPTmp[ZY,ZX]>CalcPic[ZY,ZX] Then
                CalcPic[ZY,ZX]:=CPTmp[ZY,ZX];
End;

Procedure Filter_ReliefH;
Var ZX,ZY,Diff  : Integer;
    C1,C2,Delta : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1-RelDist Do
         Begin
              C1:=CalcPic[ZY,ZX];
              C2:=CalcPic[ZY,ZX+RelDist];
              Delta:=(C1-C2);
              Diff:=Max(128-Delta);
              CalcPic[ZY,ZX]:=Diff;
         End;
End;

Procedure Filter_ReliefV;
Var ZX,ZY,Diff  : Integer;
    C1,C2,Delta : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-1-RelDist Do
         For ZX:=0 To HRes-1 Do
         Begin
              C1:=CalcPic[ZY,ZX];
              C2:=CalcPic[ZY+RelDist,ZX];
              Delta:=(C1-C2);
              Diff:=Max(128-Delta);
              CalcPic[ZY,ZX]:=Diff;
         End;
End;

Procedure Filter_ReliefM;
Var ZX,ZY,Diff  : Integer;
    C1,C2,Delta : Integer;
    CPTmp : Array[0..VRes-1,0..HRes-1] Of Byte;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1-RelDist Do
         Begin
              C1:=CalcPic[ZY,ZX];
              C2:=CalcPic[ZY,ZX+RelDist];
              Delta:=(C1-C2);
              Diff:=Max(128-Delta);
              CPTmp[ZY,ZX]:=Diff;
         End;

     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-1-RelDist Do
         For ZX:=0 To HRes-1 Do
         Begin
              C1:=CalcPic[ZY,ZX];
              C2:=CalcPic[ZY+RelDist,ZX];
              Delta:=(C1-C2);
              Diff:=Max(128-Delta);
              CalcPic[ZY,ZX]:=Diff;
         End;

     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             If CPTmp[ZY,ZX]>CalcPic[ZY,ZX] Then
                CalcPic[ZY,ZX]:=CPTmp[ZY,ZX];
End;

Procedure Filter_FaltenH;
Const FMH : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 1,-1, 0),
      ( 0, 1,-1, 0),
      ( 0, 0, 0, 0)
      );
Var ZX,ZY,New : Integer;
    MX,MY     : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMH[MY,MX];
              CalcPic[ZY,ZX]:=Abs(New);
         End;
End;

Procedure Filter_FaltenV;
Const FMV : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 1, 1, 0),
      ( 0,-1,-1, 0),
      ( 0, 0, 0, 0)
      );
Var ZX,ZY,New : Integer;
    MX,MY     : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMV[MY,MX];
              //If New<0 Then New:=0;
              CalcPic[ZY,ZX]:=Abs(New);
         End;
End;

Procedure Filter_FaltenM;
Const FMH : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 1,-1, 0),
      ( 0, 1,-1, 0),
      ( 0, 0, 0, 0)
      );
      FMV : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 1, 1, 0),
      ( 0,-1,-1, 0),
      ( 0, 0, 0, 0)
      );
Var ZX,ZY,New : Integer;
    MX,MY     : Integer;
    CTMp      : Array[0..VRes-1,0..HRes-1] Of Byte;
Begin
     FilLChar(CTmp,SizeOf(CTmp),0);
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMH[MY,MX];
              //If New<0 Then New:=0;
              CTmp[ZY,ZX]:=Abs(New);
         End;

     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMV[MY,MX];
              //If New<0 Then New:=0;
              CalcPic[ZY,ZX]:=Abs(New);
         End;

     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             CalcPic[ZY,ZX]:=CalcPic[ZY,ZX]+CTmp[ZY,ZX];
End;


Procedure Filter_FaltenMed1;
Const FMH : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 2, 1, 0),
      ( 0, 1, 0,-1),
      ( 0, 0,-1,-2)
      );
Var ZX,ZY,New : Integer;
    MX,MY     : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMH[MY,MX];
              //If New<0 Then New:=0;
              CalcPic[ZY,ZX]:=Abs(New);
         End;
End;

Procedure Filter_FaltenMed2;
Const FMV : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 0,-1,-2),
      ( 0, 1, 0,-1),
      ( 0, 2, 1, 0)
      );
Var ZX,ZY,New : Integer;
    MX,MY     : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMV[MY,MX];
              //If New<0 Then New:=0;
              CalcPic[ZY,ZX]:=Abs(New);
         End;
End;

Procedure Filter_FaltenMedM;
Const FMH : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 2, 1, 0),
      ( 0, 1, 0,-1),
      ( 0, 0,-1,-2)
      );
      FMV : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 0,-1,-2),
      ( 0, 1, 0,-1),
      ( 0, 2, 1, 0)
      );
Var ZX,ZY,New : Integer;
    MX,MY     : Integer;
    CTMp      : Array[0..VRes-1,0..HRes-1] Of Byte;
Begin
     FilLChar(CTmp,SizeOf(CTmp),0);
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMH[MY,MX];
              //If New<0 Then New:=0;
              CTmp[ZY,ZX]:=Abs(New);
         End;

     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMV[MY,MX];
              //If New<0 Then New:=0;
              CalcPic[ZY,ZX]:=Abs(New);
         End;

     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             CalcPic[ZY,ZX]:=CalcPic[ZY,ZX]+CTmp[ZY,ZX];
End;

Procedure Filter_FaltenAllDir;
Const FMHM : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 2, 1, 0),
      ( 0, 1, 0,-1),
      ( 0, 0,-1,-2)
      );
      FMVM : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 0,-1,-2),
      ( 0, 1, 0,-1),
      ( 0, 2, 1, 0)
      );
      FMH : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 1,-1, 0),
      ( 0, 1,-1, 0),
      ( 0, 0, 0, 0)
      );
      FMV : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 1, 1, 0),
      ( 0,-1,-1, 0),
      ( 0, 0, 0, 0)
      );
Var ZX,ZY,New : Integer;
    MX,MY     : Integer;
    CTMp      : Array[0..VRes-1,0..HRes-1] Of Byte;
    CTMp1     : Array[0..VRes-1,0..HRes-1] Of Byte;
    CTMp2     : Array[0..VRes-1,0..HRes-1] Of Byte;
Begin
     FillChar(CTmp,SizeOf(CTmp),0);
     FillChar(CTmp1,SizeOf(CTmp),0);
     FillChar(CTmp2,SizeOf(CTmp),0);

     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMHM[MY,MX];
              //If New<0 Then New:=0;
              CTmp[ZY,ZX]:=Abs(New);
         End;

     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMH[MY,MX];
              //If New<0 Then New:=0;
              CTmp1[ZY,ZX]:=Abs(New);
         End;

     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMV[MY,MX];
              //If New<0 Then New:=0;
              CTmp2[ZY,ZX]:=Abs(New);
         End;

     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMVM[MY,MX];
              //If New<0 Then New:=0;
              CalcPic[ZY,ZX]:=Abs(New);
         End;

     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             CalcPic[ZY,ZX]:=CalcPic[ZY,ZX]+CTmp[ZY,ZX]+
                             CTmp1[ZY,ZX]+CTmp2[ZY,ZX];
End;

Procedure Filter_Threshold;
Var ZX,ZY : Integer;
    Hell  : Byte;
    Dunk  : Byte;
    Mid   : Byte;
Const ThresVal : Integer = 60; //60
Begin
     Hell:=0;
     Dunk:=255;
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
         Begin
              If CalcPic[ZY,ZX]>Hell Then
                 Hell:=CalcPic[ZY,ZX];
              If CalcPic[ZY,ZX]<Dunk Then
                 Dunk:=CalcPic[ZY,ZX];
         End;

     Mid:=(Hell*2+Dunk*2) Div 3;

     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             If CalcPic[ZY,ZX]>Mid Then
                CalcPic[ZY,ZX]:=255
             Else
                CalcPic[ZY,ZX]:=0;
     {
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             If Abs(CalcPic[ZY,ZX]-Mid)>ThresVal Then
                CalcPic[ZY,ZX]:=0
             Else
                CalcPic[ZY,ZX]:=255;
     }
End;

Procedure Filter_ThresholdWindow;
Var ZX,ZY : Integer;
    Hell  : Byte;
    Dunk  : Byte;
    Mid   : Byte;
    WX,WY : Integer;
Const ThresVal : Integer = 10; //60
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              Hell:=0;
              Dunk:=255;
              For WY:=ZY-1 To ZY Do
                  For WX:=ZX-1 To ZX Do
                  Begin
                       If BackUp[WY,WX]<Dunk Then
                          Dunk:=BackUp[WY,WX];
                       If BackUp[WY,WX]>Hell Then
                          Hell:=BackUp[WY,WX];
                  End;
                  Mid:=(Dunk+Hell) Div 2;

              {
              For WY:=ZY-1 To ZY+1 Do
                  For WX:=ZX-1 To ZX+1 Do
                  Begin}
                       //If Abs(BackUp[ZY,ZX]-Mid)>ThresVal Then
                       If BackUp[ZY,ZX]>Mid Then
                          CalcPic[ZY,ZX]:=255
                       Else
                          CalcPic[ZY,ZX]:=0;
                  {End;}
         End;
End;

Procedure Filter_Gauss;
Const GM : Array[0..4,0..4] Of Integer=
      (
      ( 0, 1, 2, 1, 0),
      ( 1, 3, 5, 3, 1),
      ( 2, 5,10, 5, 2),
      ( 1, 3, 5, 3, 1),
      ( 0, 1, 2, 1, 0)
      );
Var ZX,ZY : Integer;
    MX,MY : Integer;
    New   : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=3 To VRes-3 Do
         For ZX:=3 To HRes-3 Do
         Begin
              New:=0;
              For MX:=-2 To 2 Do
                  For MY:=-2 To 2 Do
                      New:=New+GM[MX+2,MY+2]*Backup[ZY+MY,ZX+MX];
              CalcPic[ZY,ZX]:=Round(0.017*New);
         End;
End;

Procedure Filter_SobelX;
Const SX : Array[0..2,0..2] Of Integer=
      (
      ( 1, 2, 1),
      ( 0, 0, 0),
      (-1,-2,-1)
      );
Var ZX,ZY : Integer;
    MX,MY : Integer;
    New1  : Integer;
    New2  : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              New1:=0;
              For MX:=-1 To 1 Do
                  For MY:=-1 To 1 Do
                      New1:=New1+BackUp[ZY+MY,ZX+MX]*SX[MY+1,MX+1];
              CalcPic[ZY,ZX]:=Max(New1);
         End;
End;

Procedure Filter_SobelY;
Const SY : Array[0..2,0..2] Of Integer=
      (
      ( 1, 0,-1),
      ( 2, 0,-2),
      ( 1, 0,-1)
      );
Var ZX,ZY : Integer;
    MX,MY : Integer;
    New1  : Integer;
    New2  : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              New1:=0;
              For MX:=-1 To 1 Do
                  For MY:=-1 To 1 Do
                      New1:=New1+BackUp[ZY+MY,ZX+MX]*SY[MY+1,MX+1];
              CalcPic[ZY,ZX]:=Max(New1);
         End;
End;

Procedure Filter_SobelMagnitude;
Const SX : Array[0..2,0..2] Of Integer=
      (
      ( 1, 2, 1),
      ( 0, 0, 0),
      (-1,-2,-1)
      );
      SY : Array[0..2,0..2] Of Integer=
      (
      ( 1, 0,-1),
      ( 2, 0,-2),
      ( 1, 0,-1)
      );
Var ZX,ZY : Integer;
    MX,MY : Integer;
    New1  : Integer;
    New2  : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              New1:=0;
              For MX:=-1 To 1 Do
                  For MY:=-1 To 1 Do
                      New1:=New1+BackUp[ZY+MY,ZX+MX]*SX[MY+1,MX+1];
              New2:=0;
              For MX:=-1 To 1 Do
                  For MY:=-1 To 1 Do
                      New2:=New2+BackUp[ZY+MY,ZX+MX]*SY[MY+1,MX+1];

              CalcPic[ZY,ZX]:=Max(Round(Sqrt(New1*New1+New2*New2)));
         End;
End;

Procedure Filter_KontrastP;
Var ZX,ZY     : Integer;
    EMax,EMin : Integer;
    CDX       : Integer;
    New       : Real;
Begin
     EMax:=0; EMin:=$FF;
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
         Begin
              If CalcPic[ZY,ZX]>EMax Then
                 EMax:=CalcPic[ZY,ZX];
              If CalcPic[ZY,ZX]<EMin Then
                 EMin:=CalcPic[ZY,ZX];
         End;

     CDX:=EMax-EMin;

     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
         Begin
              New:=(255/CDX)*(CalcPic[ZY,ZX]-EMin);
              CalcPic[ZY,ZX]:=Max(Round(New));
         End;
End;

Procedure Filter_Erosion;
Const M : Array[0..2,0..2] Of Integer=
      (
      (0  ,255,  0),
      (255,255,255),
      (0  ,255,  0)
      );
Var ZX,ZY,MX,MY,New,NMin : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              New:=0;
              NMin:=$FF;
              For MX:=-1 To 1 Do
                  For MY:=-1 To 1 Do
                  Begin
                       New:=BackUp[ZY+MY,ZX+MX]-M[MY+1,MX+1]+255;
                       If New<NMin Then
                          NMin:=New;
                  End;

              CalcPic[ZY,ZX]:=NMin;
         End;
End;

Procedure Filter_Dilation;
Const M : Array[0..2,0..2] Of Integer=
      (
      (0  ,255,  0),
      (255,255,255),
      (0  ,255,  0)
      );
Var ZX,ZY,MX,MY,New,NMax : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              New:=0;
              NMax:=$00;
              For MX:=-1 To 1 Do
                  For MY:=-1 To 1 Do
                  Begin
                       New:=BackUp[ZY+MY,ZX+MX]+M[MY+1,MX+1]-255;
                       If New>NMax Then
                          NMax:=New;
                  End;

              CalcPic[ZY,ZX]:=NMax;
         End;
End;

Procedure Filter_SobelAngle;
Const SX : Array[0..2,0..2] Of Integer=
      (
      ( 1, 2, 1),
      ( 0, 0, 0),
      (-1,-2,-1)
      );
      SY : Array[0..2,0..2] Of Integer=
      (
      ( 1, 0,-1),
      ( 2, 0,-2),
      ( 1, 0,-1)
      );
Var ZX,ZY : Integer;
    MX,MY : Integer;
    New1  : Integer;
    New2  : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              New1:=0;
              For MX:=-1 To 1 Do
                  For MY:=-1 To 1 Do
                      New1:=New1+BackUp[ZY+MY,ZX+MX]*SX[MY+1,MX+1];
              New2:=0;
              For MX:=-1 To 1 Do
                  For MY:=-1 To 1 Do
                      New2:=New2+BackUp[ZY+MY,ZX+MX]*SY[MY+1,MX+1];

              If (New1=0) Or (New2=0) Then
                 CalcPic[ZY,ZX]:=0
              Else
                 CalcPic[ZY,ZX]:=Max(Round(ArcTan(New1/New2)));
         End;
End;

Procedure Filter_SemiKante;
Var T : Array[0..VRes-1,0..HRes-1] Of Byte;
    ZX,ZY : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     Move(CalcPic,T,SizeOf(CalcPic));
     Filter_SobelMagnitude;
     //Filter_ThresholdWindow;
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
             If CalcPic[ZY,ZX]>155 Then
                T[ZY,ZX]:=255;
     Move(T,CalcPic,SizeOf(CalcPic));
End;

Procedure Filter_MarrHild;
Const Mask : Array[0..10,0..10] Of Integer=
      (
      (0,0,0,-1,-1,-2,-1,-1,0,0,0),
      (0,0,-2,-4,-8,-9,-8,-4,-2,0,0),
      (0,-2,-7,-15,-22,-23,-22,-15,-7,-2,0),
      (-1,-4,-15,-24,-14,-1,-14,-24,-15,-4,-1),
      (-1,-8,-22,-14,52,103,52,-14,-22,-8,-1),
      (-2,-9,-23,-1,103,178,103,-1,-23,-9,-2),
      (-1,-8,-22,-14,52,103,52,-14,-22,-8,-1),
      (-1,-4,-15,-24,-14,-1,-14,-24,-15,-4,-1),
      (0,-2,-7,-15,-22,-23,-22,-15,-7,-2,0),
      (0,0,-2,-4,-8,-9,-8,-4,-2,0,0),
      (0,0,0,-1,-1,-2,-1,-1,0,0,0)
      );
Var ZX,ZY : Integer;
    MX,MY,New : Integer;
    T         : Array[0..VRes-1,0..HRes-1] Of Integer;
    Th        : Integer;
Begin
     Th:=10;

     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=5 To VRes-6 Do
         For ZX:=5 To HRes-6 Do
         Begin
              New:=0;
              For MX:=-5 To 5 Do
                  For MY:=-5 To 5 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*Mask[MY+5,MX+5];
              T[ZY,ZX]:=New;// Div 121;
         End;
     For ZY:=5 To VRes-6 Do
         For ZX:=5 To HRes-6 Do
         Begin
              If ((T[ZY,ZX]<-Th) And
              ((T[ZY-1,ZX]>Th) Or (T[ZY+1,ZX]>Th) Or
              (T[ZY,ZX-1]>Th) Or (T[ZY,ZX+1]>Th) Or
              (T[ZY-1,ZX-1]>Th) Or (T[ZY+1,ZX+1]>Th) Or
              (T[ZY-1,ZX+1]>Th) Or (T[ZY+1,ZX-1]>Th)))

              Or

              ((T[ZY,ZX]>Th) And
              ((T[ZY-1,ZX]<-Th) Or (T[ZY+1,ZX]<-Th) Or
              (T[ZY,ZX-1]<-Th) Or (T[ZY,ZX+1]<-Th) Or
              (T[ZY-1,ZX-1]<-Th) Or (T[ZY+1,ZX+1]<-Th) Or
              (T[ZY-1,ZX+1]<-Th) Or (T[ZY+1,ZX-1]<-Th))) Then
                  CalcPic[ZY,ZX]:=255
              Else
                  CalcPic[ZY,ZX]:=0;
         End;
End;

Procedure Filter_GaussH;
Const M : Array[0..4] Of Integer = ( 2, 5,10, 5, 2);
Var ZX,ZY,MX,New : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=2 To VRes-3 Do
         For ZX:=2 To HRes-3 Do
         Begin
              New:=0;
              For MX:=-2 To 2 Do
                  New:=New+BackUp[ZY,ZX+MX]*M[MX+2];
              CalcPic[ZY,ZX]:=New Div 24;
         End;
End;

Procedure Filter_GaussV;
Const M : Array[0..4] Of Integer = ( 2, 5,10, 5, 2);
Var ZX,ZY,MY,New : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZX:=2 To HRes-3 Do
         For ZY:=2 To VRes-3 Do
         Begin
              New:=0;
              For MY:=-2 To 2 Do
                  New:=New+BackUp[ZY+MY,ZX]*M[MY+2];
              CalcPic[ZY,ZX]:=New Div 24;
         End;
End;

Procedure Filter_Prewitt;
Const SX : Array[0..2,0..2] Of Integer=
      (
      ( 1, 1, 1),
      ( 0, 0, 0),
      (-1,-1,-1)
      );
      SY : Array[0..2,0..2] Of Integer=
      (
      ( 1, 0,-1),
      ( 1, 0,-1),
      ( 1, 0,-1)
      );
Var ZX,ZY : Integer;
    MX,MY : Integer;
    New1  : Integer;
    New2  : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              New1:=0;
              For MX:=-1 To 1 Do
                  For MY:=-1 To 1 Do
                      New1:=New1+BackUp[ZY+MY,ZX+MX]*SX[MY+1,MX+1];
              New2:=0;
              For MX:=-1 To 1 Do
                  For MY:=-1 To 1 Do
                      New2:=New2+BackUp[ZY+MY,ZX+MX]*SY[MY+1,MX+1];

              CalcPic[ZY,ZX]:=Max(Round(Sqrt(New1*New1+New2*New2)));
         End;
End;

Procedure Filter_Hurst;
Const HM : Array[1..7,1..7] Of Integer=
      ((0,0,8,7,8,0,0),
       (0,6,5,4,5,6,0),
       (8,5,3,2,3,5,8),
       (7,4,2,1,2,4,7),
       (8,5,3,2,3,5,8),
       (0,6,5,4,5,6,0),
       (0,0,8,7,8,0,0)
       );
       LDist : Array[1..8] Of Integer=
             (0,0,16,32,37,48,51,53);
Var ZX,ZY,Rgn,MX,MY,Max,Min : Integer;
    Range                   : Array[1..8] Of Integer;
    SumRD,SumR,SumD,SumD2   : Real;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=4 To VRes-2 Do
         For ZX:=4 To HRes-2 Do
         Begin
              // Range fr alle 8 Regionen berechnen
              For Rgn:=1 To 8 Do
              Begin
                   Max:=0; Min:=$FFFF;
                   For MX:=-3 To 3 Do
                       For MY:=-3 To 3 Do
                           If HM[MX+4,MY+4]=Rgn Then
                           Begin
                                If BackUp[ZY+MY,ZX+MX]>Max Then
                                   Max:=BackUp[ZY+MY,ZX+MX];
                                If BackUp[ZY+MY,ZX+MX]<Min Then
                                   Min:=BackUp[ZY+MY,ZX+MX];
                           End;
                   Range[Rgn]:=1+(Max-Min);
              End;
              // Slope fr den aktuellen Pixel berechnen

              // Summe ber log(dist)*log(range)
              SumRD:=0;
              For Rgn:=1 To 8 Do
                  SumRD:=SumRD+LDist[Rgn]*Log10(Range[Rgn]);
              // Summe ber log(dist)
              SumD:=0;
              For Rgn:=1 To 8 Do
                  SumD:=SumD+LDist[Rgn];
              // Summe ber log(range)
              SumR:=0;
              For Rgn:=1 To 8 Do
                  SumR:=SumR+Log10(Range[Rgn]);

              CalcPic[ZY,ZX]:=Round((8*(SumRD-SumD*SumR))/
                                    (8));
         End;
End;

Procedure Calc(Alg : Integer; ScriptCall : Boolean);
Var Z : Integer;
Begin
     If Alg=-1 Then
        Exit;

     If ScriptCall Then
        MainForm.FilterTimes.Value:=1;

     CalcPos:=0;
     For Z:=1 To MainForm.FilterTimes.Value Do
     Begin
          If (InCalc) And (CalcType=CT_SINGLE) Then
             ProgressForm.CalcProgress.Position:=Z-1;

          If (InCalc) And (CalcType=CT_SINGLE) And (AbortIt) Then
             Exit;

          CalcPos:=Z;
          Case Alg Of
          Blur      : Filter_Blur;
          Laplace   : Filter_Laplace;
          HExtract  : Filter_HEx;
          VExtract  : Filter_VEx;
          HAndVEx   : Filter_HVEx;
          Lighten   : Filter_Light;
          Darken    : Filter_Dark;
          MyKante   : Filter_MyKante;
          TomAlg    : Filter_TomAlg;
          GradientH : Filter_GradientH;
          GradientV : Filter_GradientV;
          GradientM : Filter_GradientM;
          ReliefH   : Filter_ReliefH;
          ReliefV   : Filter_ReliefV;
          ReliefM   : Filter_ReliefM;
          FaltenH   : Filter_FaltenH;
          FaltenV   : Filter_FaltenV;
          FaltenM   : Filter_FaltenM;
          FaltenMed1: Filter_FaltenMed1;
          FaltenMed2: Filter_FaltenMed2;
          FaltenMedM: Filter_FaltenMedM;
          Threshold : Filter_Threshold;
          FaltenAll : Filter_FaltenAllDir;
          Gauss     : Filter_Gauss;
          SobelX    : Filter_SobelX;
          SobelY    : Filter_SobelY;
          KontrastP : Filter_KontrastP;
          Erosion   : Filter_Erosion;
          Dilation  : Filter_Dilation;
          ThresWin  : Filter_ThresholdWindow;
          SobelM    : Filter_SobelMagnitude;
          SobelA    : Filter_SobelAngle;
          SemiKante : Filter_SemiKante;
          MarrHild  : Filter_MarrHild;
          GaussH    : Filter_GaussH;
          GaussV    : Filter_GaussV;
          Prewitt   : Filter_Prewitt;
          RGNGrow   : Begin End;
          Hurst     : Filter_Hurst;
          End;
          Draw_Pic(False);
     End;
     Draw_Pic(True);
End;

Procedure Add2Hist(FIdx,FTime : Integer);
Var AddLine : String;
Begin
     Inc(HistCount);
     AddLine:=(*'#'+IntToStr(HistCount)+' '+*)MainForm.FilterList.Items[FIdx]+' x '+IntToStr(FTime);
     MainForm.FHist.Items.Add(AddLine);
End;

procedure Script_Thread(Dummy : Pointer);
Var Z : Integer;
Begin
     For Z:=0 To ScriptCount-1 Do
     Begin
          ProgressForm.CalcProgress.Position:=Z;
          Calc(ScriptList[Z],True);
          If AbortIt Then
          Begin
               ProgressForm.Close;
               Exit;
          End;
     End;

     ProgressForm.Close;
End;

procedure TMainForm.Script_Filter;
Begin
     ProgressForm.CalcProgress.Max:=ScriptCount-1;

     If ScriptReset.Checked Then
        Reset_Calc;

     AbortIt:=False;
     // Create thread for Calc
     CreateThread(NIL,0,@Script_Thread,NIL,0,ScriptTHID);
     ProgressForm.ShowModal;
End;

procedure Single_Thread(Dummy : Pointer);
Var Time : DWord;
Begin
     InCalc:=True;
     Calc(MainForm.TreeView1.Selected.SelectedIndex,False);
     InCalc:=False;
     ProgressForm.Close;
End;

procedure TMainForm.Single_Filter;
Begin
     ProgressForm.CalcProgress.Max:=FilterTimes.Value-1;

     // Create thread for Calc
     AbortIt:=False;
     CreateThread(NIL,0,@Single_Thread,NIL,0,SingleTHID);
     ProgressForm.ShowModal;

     Add2Hist(TreeView1.Selected.SelectedIndex,FilterTimes.Value);
End;

procedure TMainForm.Perform_Calc;
Begin
     Case CalcType Of
     CT_SINGLE : Single_Filter;
     CT_SCRIPT : Script_Filter;
     End;
End;

procedure TMainForm.UseFilterBtnClick(Sender: TObject);
begin
     //If (GLoaded) And (FilterList.ItemIndex>-1) Then
     If (GLoaded) And (TreeView1.Selected.SelectedIndex>-1) Then
     Begin
          //Calc(FilterList.ItemIndex);
          //Add2Hist(FilterList.ItemIndex,FilterTimes.Value);
          BrightRun:=False;
          SwitchBrightPic;

          CalcType:=CT_SINGLE;
          Perform_Calc;
     End;
end;

procedure TMainForm.FilterListClick(Sender: TObject);
begin
     FilterTimes.Value:=1;
end;

procedure TMainForm.ClearHistBtnClick(Sender: TObject);
begin
     HistCount:=0;
     FHist.Items.Clear;
end;

procedure TMainForm.MiniImgClick(Sender: TObject);
begin
     Application.Minimize;
end;

procedure TMainForm.CloseImgClick(Sender: TObject);
begin
     Application.Terminate;
end;

procedure TMainForm.FilterListDblClick(Sender: TObject);
begin
     Inc(ScriptCount);
     ScriptList[ScriptCount-1]:=FilterList.ItemIndex;
     Script.Items.Add(FilterList.Items[FilterList.ItemIndex]);
end;

Procedure Erase_From_List(I : Integer);
Var Z : Integer;
Begin
     If I=0 Then
     Begin
          For Z:=0 To MainForm.Script.Items.Count-2 Do
              ScriptList[Z]:=ScriptList[Z+1];
          Dec(ScriptCount);
     End
     Else
     If I=MainForm.Script.Items.Count-1 Then
     Begin
          Dec(ScriptCount);
     End
     Else
     Begin
          For Z:=I To MainForm.Script.Items.Count-2 Do
              ScriptList[Z]:=ScriptList[Z+1];
          Dec(ScriptCount);
     End;
End;

procedure TMainForm.EraseScriptbtnClick(Sender: TObject);
begin
     If Script.ItemIndex=-1 Then
        Exit;
     Erase_From_List(Script.ItemIndex);
     Script.Items.Delete(Script.ItemIndex);
end;

procedure TMainForm.RunScriptBtnClick(Sender: TObject);
Var Z : Integer;
begin
     If Script.Items.Count>0 Then
     Begin
          BrightRun:=False;
          SwitchBrightPic;

          CalcType:=CT_SCRIPT;
          Perform_Calc;
     End;
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
     BlitItPic;
     BlitItHist;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
     BlitItPic;
     BlitItHist;
end;

Procedure Load_Script(N : String);
Var D : File;
    Z : Word;
Begin
     AssignFile(D,N); ReSet(D,1);
     BlockRead(D,ScriptCount,SizeOf(ScriptCount));
     For Z:=0 To ScriptCount-1 Do
     Begin
          BlockRead(D,ScriptList[Z],2);
          MainForm.Script.Items.Add(MainForm.FilterList.Items[ScriptList[Z]]);
     End;
     CloseFile(D);
End;

procedure TMainForm.LoadScriptBtnClick(Sender: TObject);
begin
     If ScriptOpenDialog.Execute Then
     Begin
          ScriptCount:=0;
          Script.Items.Clear;
          Load_Script(ScriptOpenDialog.FileName);
     End;
end;

Procedure Save_Script(N : String);
Var D : File;
    Z : Word;
Begin
     AssignFile(D,N); ReWrite(D,1);
     BlockWrite(D,ScriptCount,SizeOf(ScriptCount));
     For Z:=0 To ScriptCount-1 Do
         BlockWrite(D,ScriptList[Z],2);
     CloseFile(D);
End;

procedure TMainForm.SaveScriptBtnClick(Sender: TObject);
begin
     If SaveScriptDialog.Execute Then
        Save_Script(SaveScriptDialog.FileName);
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
     BlitItPic;
     BlitItHist;
end;

procedure TMainForm.ClrScriptBtnClick(Sender: TObject);
begin
     ScriptCount:=0;
     Script.Items.Clear;
end;

procedure TMainForm.TreeView1DblClick(Sender: TObject);
begin
     If TreeView1.Selected.SelectedIndex>-1 Then
     Begin
          Inc(ScriptCount);
          ScriptList[ScriptCount-1]:=TreeView1.Selected.SelectedIndex;
          Script.Items.Add(FilterList.Items[TreeView1.Selected.SelectedIndex]);
     End;
end;

Procedure PutPixelRGB(X,Y,R,G,B : Integer);
Begin
     If (Y>=0) And (X>=0) And (Y<WinDY) And (X<WinDX) Then
        MainBuf[Y,X]:=ColorCode(R,G,B);
End;

Procedure GetPixelRGB(X,Y : Integer; Var R,G,B : Integer);
Var Col : Word;
Begin
     Col:=MainBuf[Y,X];
     R:=(Col Shr 10) And 31;
     G:=(Col Shr 5) And 31;
     B:=Col And 31;
End;

Procedure LineRGB(X1,Y1,X2,Y2 : Integer; R,G,B : Word; Style : Word);
Var DX,DY : Real;
    Lang  : Integer;
    X,Y   : Real;
    GR,GG,GB : Integer;
Begin
     If Abs(X2-X1)>Abs(Y2-Y1) Then
        Lang:=Abs(X2-X1)
     Else
        Lang:=Abs(Y2-Y1);

     If Lang=0 Then Exit;

     DX:=(X2-X1)/Lang;
     DY:=(Y2-Y1)/Lang;

     X:=X1; Y:=Y1;
     While (Lang>0) Do
     Begin
          Case Style Of
          ST_NORMAL : PutPixelRGB(Round(X),Round(Y),R,G,B);
          ST_XOR    : Begin
                           GetPixelRGB(Round(X),Round(Y),GR,GG,GB);
                           GR:=GR Xor R;
                           GG:=GG Xor G;
                           GB:=GB Xor B;
                           PutPixelRGB(Round(X),Round(Y),GR,GG,GB);
                      End;
          ST_OR     : Begin
                           GetPixelRGB(Round(X),Round(Y),GR,GG,GB);
                           GR:=GR Or R;
                           GG:=GG Or G;
                           GB:=GB Or B;
                           PutPixelRGB(Round(X),Round(Y),GR,GG,GB);
                      End;
          ST_AND    : Begin
                           GetPixelRGB(Round(X),Round(Y),GR,GG,GB);
                           GR:=GR And R;
                           GG:=GG And G;
                           GB:=GB And B;
                           PutPixelRGB(Round(X),Round(Y),GR,GG,GB);
                      End;
          End;

          Dec(Lang);
          X:=X+DX;
          Y:=Y+DY;
     End;
End;

procedure TMainForm.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     If Button=MbLeft Then
     Begin
          If InRect(X,Y,DrawRect) Then
          Begin
               Draw_Pic(TRUE);

               MDown:=True;
               StartCapX:=X-DrawRect.Left;
               StartCapY:=Y-DrawRect.Top;

               LineRGB(StartCapX-5,StartCapY,StartCapX+5,StartCapY,31,31,31,ST_NORMAL);
               LineRGB(StartCapX,StartCapY-5,StartCapX,StartCapY+5,31,31,31,ST_NORMAL);
          End;
     End
     Else
     If (Button=MbRight) And (Not(MDown)) Then
     Begin
          If InRect(X,Y,DrawRect) Then
          Begin
               Draw_Pic(True);
               Show_Histogramm;

               BrightRun:=False;
               SwitchBrightPic;
          End;
     End;
end;

procedure TMainForm.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     If MDown Then
     Begin
          X:=X-DrawRect.Left;
          Y:=Y-DrawRect.Top;
          LineRGB(StartCapX,StartCapY,X,Y,31,0,0,ST_XOR);
          BlitItPic;
          LineRGB(StartCapX,StartCapY,X,Y,31,0,0,ST_XOR);
     End;
end;

Procedure Capture_ColorLine;
Var DX,DY : Real;
    Lang  : Integer;
    X,Y   : Real;
    GR,GG,GB : Integer;
    ZX,ZY    : Integer;
    XFac,YFac : Real;
    CurrCol   : Integer;
    LangX     : Integer;
Begin
     If Abs(EndCapX-StartCapX)>Abs(EndCapY-StartCapY) Then
        Lang:=Abs(EndCapX-StartCapX)
     Else
        Lang:=Abs(EndCapY-StartCapY);

     If Lang=0 Then Exit;

     ClearHistPic;

     DX:=(EndCapX-StartCapX)/Lang;
     DY:=(EndCapY-StartCapY)/Lang;

     YFac:=199/256;
     XFac:=(HistDX-2)/Lang;

     X:=StartCapX; Y:=StartCapY;
     LangX:=-1;
     While (Lang>0) Do
     Begin
          Dec(Lang);
          Inc(LangX);
          X:=X+DX;
          Y:=Y+DY;

          If (Y>=0) And (Y<WinDY) And (X>=0) And (X<=WinDX) Then
          Begin
               CurrCol:=CalcPic[Round(Y),Round(X)];

               For ZX:=0 To Round(XFac) Do
                   For ZY:=199-Round(YFac*CurrCol) To 199 Do
                       MainHist[ZY,Round(LangX*XFac)+ZX]:=HistPix;
          End;
     End;

     BlitItHist;
End;

procedure TMainForm.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     If Button=MbLeft Then
        If MDown Then
        Begin
             MDown:=False;

             X:=X-DrawRect.Left;
             Y:=Y-DrawRect.Top;
             LineRGB(StartCapX,StartCapY,X,Y,31,0,0,ST_NORMAL);

             EndCapX:=X;
             EndCapY:=Y;

             If (EndCapX=StartCapX) And (EndCapY=StartCapY) Then
             Begin
                  Draw_Pic(True);
                  Show_Histogramm;

                  BrightRun:=False;
                  SwitchBrightPic;
             End
             Else
             Begin
                  LineRGB(X-5,Y,X+5,Y,31,31,31,ST_NORMAL);
                  LineRGB(X,Y-5,X,Y+5,31,31,31,ST_NORMAL);

                  BrightRun:=True;
                  SwitchBrightPic;
             End;

             Capture_ColorLine;
        End;
end;

procedure TMainForm.TreeView1Click(Sender: TObject);
begin
     FilterTimes.Value:=1;
end;

procedure TMainForm.TitleImgClick(Sender: TObject);
begin
     TitlePopup.PopUp(TitleImg.Left+MainForm.Left,TitleImg.Top+MainForm.Top+20);
end;

procedure TMainForm.TitleImgDblClick(Sender: TObject);
begin
     Application.Terminate;
end;

procedure TMainForm.Minimieren1Click(Sender: TObject);
begin
     Application.Minimize;
end;

procedure TMainForm.Close1Click(Sender: TObject);
begin
     Application.Terminate;
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
     AboutForm.ShowModal;
end;

end.
