unit KantExUnit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, DirectGraph, StdCtrls, Spin, Math, QuickRpt, MyWin;

type
  TMainForm = class(TForm)
    Bevel1: TBevel;
    StatusBar1: TStatusBar;
    FileName: TEdit;
    Label1: TLabel;
    LoadGfxBtn: TButton;
    ResetCalcBtn: TButton;
    OpenDialog1: TOpenDialog;
    FilterList: TListBox;
    UseFilterBtn: TButton;
    Times: TSpinEdit;
    FHist: TListBox;
    ClearHistBtn: TButton;
    Label2: TLabel;
    Bevel2: TBevel;
    Hist: TImage;
    Label3: TLabel;
    CC: TLabel;
    Label4: TLabel;
    MC: TLabel;
    AddyWin: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure LoadGfxBtnClick(Sender: TObject);
    procedure ResetCalcBtnClick(Sender: TObject);
    procedure UseFilterBtnClick(Sender: TObject);
    procedure FilterListClick(Sender: TObject);
    procedure ClearHistBtnClick(Sender: TObject);
    procedure HistMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure AddyWinClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

Const Blur      = 0000;
      LapLace   = 0001;
      HExtract  = 0002;
      VExtract  = 0003;
      HAndVEx   = 0004;
      Lighten   = 0005;
      Darken    = 0006;
      MyKante   = 0007;
      TomAlg    = 0008;
      GradientH = 0009;
      GradientV = 0010;
      GradientM = 0011;
      ReliefH   = 0012;
      ReliefV   = 0013;
      ReliefM   = 0014;
      FaltenH   = 0015;
      FaltenV   = 0016;
      FaltenM   = 0017;
      FaltenMed1= 0018;
      FaltenMed2= 0019;
      FaltenMedM= 0020;
      Threshold = 0021;
      FaltenAll = 0022;
      Gauss     = 0023;
      SobelX    = 0024;
      SobelY    = 0025;
      SobelM    = 0026;
      KontrastP = 0027;
      Erosion   = 0028;
      Dilation  = 0029;
      ThresWin  = 0030;
      SobelA    = 0031;
      SemiKante = 0032;
      MarrHild  = 0033;
      GaussH    = 0034;
      GaussV    = 0035;
      Prewitt   = 0036;
      RGNGrow   = 0037;
      Hurst     = 0038;

      RelDist = 1;

      HRes = 320;
      VRes = 200;

var
  MainForm  : TMainForm;
  B         : GBuffer;

  Pic       : Array[0..VRes-1,0..HRes-1] Of Byte;
  GLoaded   : Boolean;
  GrayPal   : TRGBPal;
  TmpPal    : Array[0..255,1..3] Of Byte;
  Calced    : Boolean;
  CalcPic   : Array[0..VRes-1,0..HRes-1] Of Byte;
  BackUp    : Array[0..VRes-1,0..HRes-1] Of Byte;
  HistCount : LongInt;
  Histo     : Array[0..255] Of Word;

implementation

uses AddUnit;

{$R *.DFM}

Function Upper(S : String) : String;
Var T : String;
    Z : Integer;
Begin
     T:='';
     For Z:=1 To Length(S) Do
         T:=T+UpCase(S[Z]);
     Result:=T;
End;

Procedure Status(S : String);
Begin
     MainForm.StatusBar1.SimpleText:=S;
End;

Procedure Import_Log;
Var D : Text;
    ZX,ZY,C : Integer;
    Line  : String;
    AX,AY : Integer;
Begin
     AssignFile(D,MainForm.FileName.Text); {$I-} Reset(D); {$I+}
     If IOResult<>0 Then
     Begin
          Status('File error occured while opening '+MainForm.FileName.Text+'...');
          GLoaded:=False;
          Exit;
     End;
     Line:='';

     FillChar(Pic,SizeOf(Pic),0);

     For ZY:=0 To 59 Do
     Begin
          ReadLn(D,Line);
          If Length(Line)<79 Then
             ReadLn(D,Line);
          For ZX:=0 To 79 Do
          Begin
               C:=255-((Ord(Line[ZX+1])-64)*4);

               Pic[ZY,ZX]:=C;

               {
               For AX:=0 To 3 Do
                   For AY:=0 To 3 Do
                       Pic[ZY*4+AY,ZX*4+AX]:=C;
               }
               {
               Pic[ZY*2,ZX*2]:=C;
               Pic[ZY*2+1,ZX*2]:=C;
               Pic[ZY*2,ZX*2+1]:=C;
               Pic[ZY*2+1,ZX*2+1]:=C;
               }
          End;
     End;

     CloseFile(D);
     GLoaded:=True;
End;

Procedure Load_Grafix;
Var D : File;
    PPM : Boolean;
    ZX,ZY : Integer;
Begin
     If Upper(Copy(MainForm.FileName.Text,
              Length(MainForm.FileName.Text)-2,
              3))='LOG' Then
     Begin
          Import_Log;
          //If Gloaded Then
          //   Status('File successfully loaded...');
          Exit;
     End;

     AssignFile(D,MainForm.FileName.Text); {$I-} Reset(D,1); {$I+}
     If IOResult<>0 Then
     Begin
          Status('File error occured while opening '+MainForm.FileName.Text+'...');
          GLoaded:=False;
          Exit;
     End;

     If Upper(Copy(MainForm.FileName.Text,
              Length(MainForm.FileName.Text)-2,
              3))='PPM' Then
        PPM:=True
     Else
        PPM:=False;

     If PPM Then
        Seek(D,14);

     BlockRead(D,Pic,HRes*VRes);

     If PPM Then
        For ZY:=0 To VRes-1 Do
            For ZX:=0 To HRes-1 Do
                Pic[ZY,ZX]:=Pic[ZY,ZX]*4;

     CloseFile(D);
     Status('File successfully loaded...');
     GLoaded:=True;
End;

procedure TMainForm.FormCreate(Sender: TObject);
Var D : File;
    Tmp : Integer;
begin
     Tmp:=2039;
     CC.Caption:=IntToStr(Tmp);

     Init_DirectDraw(MainForm.Handle,HRes,VRes,1,1);
     If Not(DXInit) Then
        Application.Terminate;
     LoadPal('GRAY2.PAL',GrayPal);

     AssignFile(D,'GRAY2.PAL'); Reset(D,1);
     BlockRead(D,TmpPal,768);
     CloseFile(D);

     B.Init(HRes,VRes);
     B.Cls;
     B.SetPalette(GrayPal);
     GLoaded:=False;
     Calced:=False;
     HistCount:=0;
     AddWin:=False;
end;

Procedure Show_Histogramm;
Var ZX,ZY : Integer;
    Max : Word;
    Fac : Real;
Begin
     FillChar(Histo,SizeOf(Histo),0);
     Max:=0;
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
         Begin
              Inc(Histo[CalcPic[ZY,ZX]]);
              If (Histo[CalcPic[ZY,ZX]]>Max) And (CalcPic[ZY,ZX]>0) Then
              Begin
                   MainForm.MC.Caption:=IntToStr(CalcPic[ZY,ZX]);
                   Max:=Histo[CalcPic[ZY,ZX]];
              End;
         End;
     If Max<1 Then Max:=1;
     Fac:=160/Max;
     For ZY:=0 To 255 Do
     Begin
          MainForm.Hist.Canvas.Pen.Color:=$0000;
          MainForm.Hist.Canvas.MoveTo(0,ZY);
          MainForm.Hist.Canvas.LineTo(Round(Fac*Histo[ZY]),ZY);
          MainForm.Hist.Canvas.MoveTo(Round(Fac*Histo[ZY]),ZY);
          MainForm.Hist.Canvas.Pen.Color:=$FFFFFF;
          MainForm.Hist.Canvas.LineTo(160,ZY);
     End;
End;

Procedure Draw_Pic(H : Boolean);
Var ZX,ZY : Integer;
    RGBVal : LongInt;
    C      : Integer;
Begin
     If H Then
        Show_Histogramm;
     B.Cls;
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             B.PutPixel(ZX,ZY,CalcPic[ZY,ZX]);
     B.BlitIt;

     If AddWin Then
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
         Begin
              C:=CalcPic[ZY,ZX];
              RGBVal:=RGB(TmpPal[C,1] Shl 2,TmpPal[C,2] Shl 2,TmpPal[C,3] Shl 2);
              AddForm.NormPic.Canvas.Pixels[ZX,ZY]:=RGBVal;
         End;
End;

Procedure Reset_Calc;
Begin
     Calced:=False;
     Move(Pic,CalcPic,SizeOf(Pic));
     MainForm.FHist.Items.Clear;
     HistCount:=0;
     Draw_Pic(True);
End;

Procedure Filter_Blur;
Var ZX,ZY : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              CalcPic[ZY,ZX]:=(BackUp[ZY-1,ZX]+BackUp[ZY+1,ZX]+
                               BackUp[ZY,ZX+1]+BackUp[ZY,ZX-1]) Div 4;
         End;
End;

Procedure Filter_Laplace;
Var ZX,ZY : Integer;
    Tmp   : LongInt;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              Tmp:=4*BackUp[ZY,ZX]-
                     BackUp[ZY-1,ZX+1]-
                     BackUp[ZY+1,ZX+1]-
                     BackUp[ZY+1,ZX]-
                     BackUp[ZY+1,ZX+2];
              Tmp:=Tmp Div 9;
              CalcPic[ZY,ZX]:=Tmp;
         End;
End;

Procedure Filter_HEx;
Var ZX,ZY : Integer;
    Tmp   : LongInt;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              Tmp:=2*BackUp[ZY,ZX+1]-
                   2*BackUp[ZY,ZX-1]+
                     BackUp[ZY-1,ZX+1]-
                     BackUp[ZY-1,ZX-1]+
                     BackUp[ZY+1,ZX+1]-
                     BackUp[ZY+1,ZX-1];
              Tmp:=Tmp Div 9;
              CalcPic[ZY,ZX]:=Tmp;
         End;
End;

Procedure Filter_VEx;
Var ZX,ZY : Integer;
    Tmp   : LongInt;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              Tmp:=2*BackUp[ZY+1,ZX]-
                   2*BackUp[ZY-1,ZX]+
                     BackUp[ZY+1,ZX-1]-
                     BackUp[ZY-1,ZX-1]+
                     BackUp[ZY+1,ZX+1]-
                     BackUp[ZY-1,ZX+1];
              Tmp:=Tmp Div 9;
              CalcPic[ZY,ZX]:=Tmp;
         End;
End;

Procedure Filter_HVEx;
Var ZX,ZY : Integer;
    Tmp   : LongInt;
    CPTmp : Array[0..VRes-1,0..HRes-1] Of Byte;
Begin
     // vertikale Extraktion
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              Tmp:=2*BackUp[ZY+1,ZX]-
                   2*BackUp[ZY-1,ZX]+
                     BackUp[ZY+1,ZX-1]-
                     BackUp[ZY-1,ZX-1]+
                     BackUp[ZY+1,ZX+1]-
                     BackUp[ZY-1,ZX+1];
              Tmp:=Tmp Div 9;
              CPTmp[ZY,ZX]:=Tmp;
         End;

     // horizontale Extraktion
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              Tmp:=2*BackUp[ZY,ZX+1]-
                   2*BackUp[ZY,ZX-1]+
                     BackUp[ZY-1,ZX+1]-
                     BackUp[ZY-1,ZX-1]+
                     BackUp[ZY+1,ZX+1]-
                     BackUp[ZY+1,ZX-1];
              Tmp:=Tmp Div 9;
              CalcPic[ZY,ZX]:=(Tmp+CpTmp[ZY,ZX])Div 2;
         End;
End;

Procedure Filter_Light;
Var ZX,ZY : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             If (CalcPic[ZY,ZX]<255) And (CalcPic[ZY,ZX]>0) Then
                CalcPic[ZY,ZX]:=CalcPic[ZY,ZX]+1;
End;

Procedure Filter_Dark;
Var ZX,ZY : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             If CalcPic[ZY,ZX]>0 Then
                CalcPic[ZY,ZX]:=CalcPic[ZY,ZX]-1;
End;

Procedure Filter_MyKante;
Var Z : Integer;
Begin
     Filter_HVEx;
     For Z:=1 To 5 Do
         Filter_Blur;
     For Z:=1 To 255 Do
         Filter_Light;
End;

Procedure Filter_TomAlg;
Var ZX,ZY : Integer;
    Z     : Word;
    ColAmount : Array[0..255] Of Word;
    Max,Min   : Word;
Begin
     Max:=0; Min:=$FFFF;
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     FillChar(ColAmount,SizeOf(ColAmount),0);

     // Farben zhlen
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             Inc(ColAmount[CalcPic[ZY,ZX]]);

     // Minimumanzahl finden
     For Z:=0 To 255 Do
         If ColAmount[Z]<Min Then
            Min:=ColAmount[Z];

     // Minimumanzahl finden
     For Z:=0 To 255 Do
         If ColAmount[Z]>Max Then
            Max:=ColAmount[Z];

     // Filter anwenden
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
         Begin
              CalcPic[ZY,ZX]:=CalcPic[ZY,ZX]*Round(Max/ColAmount[CalcPic[ZY,ZX]]);
         End;
End;

Function Max(I : Integer) : Integer;
Begin
     If I>255 Then
        Result:=255
     Else
     If I<0 Then
        Result:=0
     Else
        Result:=I;
End;

Procedure Filter_GradientH;
Var ZX,ZY,Diff  : Integer;
    C1,C2,Delta : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-4 Do
         Begin
              C1:=CalcPic[ZY,ZX];
              C2:=CalcPic[ZY,ZX+3];
              Delta:=Abs(C1-C2);
              Diff:=Max(255-Delta);
              CalcPic[ZY,ZX]:=Diff;
         End;
End;

Procedure Filter_GradientV;
Var ZX,ZY,Diff  : Integer;
    C1,C2,Delta : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-1 Do
         Begin
              C1:=CalcPic[ZY,ZX];
              C2:=CalcPic[ZY+3,ZX];
              Delta:=Abs(C1-C2);
              Diff:=Max(255-Delta);
              CalcPic[ZY,ZX]:=Diff;
         End;
End;

Procedure Filter_GradientM;
Var ZX,ZY,Diff  : Integer;
    C1,C2,Delta : Integer;
    CPTmp : Array[0..VRes-1,0..HRes-1] Of Byte;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-4 Do
         Begin
              C1:=CalcPic[ZY,ZX];
              C2:=CalcPic[ZY,ZX+3];
              Delta:=Abs(C1-C2);
              Diff:=Max(255-Delta);
              CPTmp[ZY,ZX]:=Diff;
         End;

     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-1 Do
         Begin
              C1:=CalcPic[ZY,ZX];
              C2:=CalcPic[ZY+3,ZX];
              Delta:=Abs(C1-C2);
              Diff:=Max(255-Delta);
              CalcPic[ZY,ZX]:=Diff;
         End;

     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             If CPTmp[ZY,ZX]>CalcPic[ZY,ZX] Then
                CalcPic[ZY,ZX]:=CPTmp[ZY,ZX];
End;

Procedure Filter_ReliefH;
Var ZX,ZY,Diff  : Integer;
    C1,C2,Delta : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1-RelDist Do
         Begin
              C1:=CalcPic[ZY,ZX];
              C2:=CalcPic[ZY,ZX+RelDist];
              Delta:=(C1-C2);
              Diff:=Max(128-Delta);
              CalcPic[ZY,ZX]:=Diff;
         End;
End;

Procedure Filter_ReliefV;
Var ZX,ZY,Diff  : Integer;
    C1,C2,Delta : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-1-RelDist Do
         For ZX:=0 To HRes-1 Do
         Begin
              C1:=CalcPic[ZY,ZX];
              C2:=CalcPic[ZY+RelDist,ZX];
              Delta:=(C1-C2);
              Diff:=Max(128-Delta);
              CalcPic[ZY,ZX]:=Diff;
         End;
End;

Procedure Filter_ReliefM;
Var ZX,ZY,Diff  : Integer;
    C1,C2,Delta : Integer;
    CPTmp : Array[0..VRes-1,0..HRes-1] Of Byte;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1-RelDist Do
         Begin
              C1:=CalcPic[ZY,ZX];
              C2:=CalcPic[ZY,ZX+RelDist];
              Delta:=(C1-C2);
              Diff:=Max(128-Delta);
              CPTmp[ZY,ZX]:=Diff;
         End;

     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-1-RelDist Do
         For ZX:=0 To HRes-1 Do
         Begin
              C1:=CalcPic[ZY,ZX];
              C2:=CalcPic[ZY+RelDist,ZX];
              Delta:=(C1-C2);
              Diff:=Max(128-Delta);
              CalcPic[ZY,ZX]:=Diff;
         End;

     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             If CPTmp[ZY,ZX]>CalcPic[ZY,ZX] Then
                CalcPic[ZY,ZX]:=CPTmp[ZY,ZX];
End;

Procedure Filter_FaltenH;
Const FMH : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 1,-1, 0),
      ( 0, 1,-1, 0),
      ( 0, 0, 0, 0)
      );
Var ZX,ZY,New : Integer;
    MX,MY     : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMH[MY,MX];
              CalcPic[ZY,ZX]:=Abs(New);
         End;
End;

Procedure Filter_FaltenV;
Const FMV : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 1, 1, 0),
      ( 0,-1,-1, 0),
      ( 0, 0, 0, 0)
      );
Var ZX,ZY,New : Integer;
    MX,MY     : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMV[MY,MX];
              //If New<0 Then New:=0;
              CalcPic[ZY,ZX]:=Abs(New);
         End;
End;

Procedure Filter_FaltenM;
Const FMH : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 1,-1, 0),
      ( 0, 1,-1, 0),
      ( 0, 0, 0, 0)
      );
      FMV : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 1, 1, 0),
      ( 0,-1,-1, 0),
      ( 0, 0, 0, 0)
      );
Var ZX,ZY,New : Integer;
    MX,MY     : Integer;
    CTMp      : Array[0..VRes-1,0..HRes-1] Of Byte;
Begin
     FilLChar(CTmp,SizeOf(CTmp),0);
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMH[MY,MX];
              //If New<0 Then New:=0;
              CTmp[ZY,ZX]:=Abs(New);
         End;

     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMV[MY,MX];
              //If New<0 Then New:=0;
              CalcPic[ZY,ZX]:=Abs(New);
         End;

     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             CalcPic[ZY,ZX]:=CalcPic[ZY,ZX]+CTmp[ZY,ZX];
End;


Procedure Filter_FaltenMed1;
Const FMH : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 2, 1, 0),
      ( 0, 1, 0,-1),
      ( 0, 0,-1,-2)
      );
Var ZX,ZY,New : Integer;
    MX,MY     : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMH[MY,MX];
              //If New<0 Then New:=0;
              CalcPic[ZY,ZX]:=Abs(New);
         End;
End;

Procedure Filter_FaltenMed2;
Const FMV : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 0,-1,-2),
      ( 0, 1, 0,-1),
      ( 0, 2, 1, 0)
      );
Var ZX,ZY,New : Integer;
    MX,MY     : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMV[MY,MX];
              //If New<0 Then New:=0;
              CalcPic[ZY,ZX]:=Abs(New);
         End;
End;

Procedure Filter_FaltenMedM;
Const FMH : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 2, 1, 0),
      ( 0, 1, 0,-1),
      ( 0, 0,-1,-2)
      );
      FMV : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 0,-1,-2),
      ( 0, 1, 0,-1),
      ( 0, 2, 1, 0)
      );
Var ZX,ZY,New : Integer;
    MX,MY     : Integer;
    CTMp      : Array[0..VRes-1,0..HRes-1] Of Byte;
Begin
     FilLChar(CTmp,SizeOf(CTmp),0);
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMH[MY,MX];
              //If New<0 Then New:=0;
              CTmp[ZY,ZX]:=Abs(New);
         End;

     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMV[MY,MX];
              //If New<0 Then New:=0;
              CalcPic[ZY,ZX]:=Abs(New);
         End;

     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             CalcPic[ZY,ZX]:=CalcPic[ZY,ZX]+CTmp[ZY,ZX];
End;

Procedure Filter_FaltenAllDir;
Const FMHM : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 2, 1, 0),
      ( 0, 1, 0,-1),
      ( 0, 0,-1,-2)
      );
      FMVM : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 0,-1,-2),
      ( 0, 1, 0,-1),
      ( 0, 2, 1, 0)
      );
      FMH : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 1,-1, 0),
      ( 0, 1,-1, 0),
      ( 0, 0, 0, 0)
      );
      FMV : Array[0..3,0..3] Of Integer=
      (
      ( 0, 0, 0, 0),
      ( 0, 1, 1, 0),
      ( 0,-1,-1, 0),
      ( 0, 0, 0, 0)
      );
Var ZX,ZY,New : Integer;
    MX,MY     : Integer;
    CTMp      : Array[0..VRes-1,0..HRes-1] Of Byte;
    CTMp1     : Array[0..VRes-1,0..HRes-1] Of Byte;
    CTMp2     : Array[0..VRes-1,0..HRes-1] Of Byte;
Begin
     FillChar(CTmp,SizeOf(CTmp),0);
     FillChar(CTmp1,SizeOf(CTmp),0);
     FillChar(CTmp2,SizeOf(CTmp),0);

     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMHM[MY,MX];
              //If New<0 Then New:=0;
              CTmp[ZY,ZX]:=Abs(New);
         End;

     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMH[MY,MX];
              //If New<0 Then New:=0;
              CTmp1[ZY,ZX]:=Abs(New);
         End;

     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMV[MY,MX];
              //If New<0 Then New:=0;
              CTmp2[ZY,ZX]:=Abs(New);
         End;

     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-4 Do
         For ZX:=0 To HRes-4 Do
         Begin
              New:=0;
              For MX:=0 To 3 Do
                  For MY:=0 To 3 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*FMVM[MY,MX];
              //If New<0 Then New:=0;
              CalcPic[ZY,ZX]:=Abs(New);
         End;

     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             CalcPic[ZY,ZX]:=CalcPic[ZY,ZX]+CTmp[ZY,ZX]+
                             CTmp1[ZY,ZX]+CTmp2[ZY,ZX];
End;

Procedure Filter_Threshold;
Var ZX,ZY : Integer;
    Hell  : Byte;
    Dunk  : Byte;
    Mid   : Byte;
Const ThresVal : Integer = 60; //60
Begin
     Hell:=0;
     Dunk:=255;
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
         Begin
              If CalcPic[ZY,ZX]>Hell Then
                 Hell:=CalcPic[ZY,ZX];
              If CalcPic[ZY,ZX]<Dunk Then
                 Dunk:=CalcPic[ZY,ZX];
         End;

     Mid:=(Hell*2+Dunk*2) Div 3;

     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
             If Abs(CalcPic[ZY,ZX]-Mid)>ThresVal Then
                CalcPic[ZY,ZX]:=0
             Else
                CalcPic[ZY,ZX]:=255;
End;

Procedure Filter_ThresholdWindow;
Var ZX,ZY : Integer;
    Hell  : Byte;
    Dunk  : Byte;
    Mid   : Byte;
    WX,WY : Integer;
Const ThresVal : Integer = 10; //60
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              Hell:=0;
              Dunk:=255;
              For WY:=ZY-1 To ZY Do
                  For WX:=ZX-1 To ZX Do
                  Begin
                       If BackUp[WY,WX]<Dunk Then
                          Dunk:=BackUp[WY,WX];
                       If BackUp[WY,WX]>Hell Then
                          Hell:=BackUp[WY,WX];
                  End;
                  Mid:=(Dunk+Hell) Div 2;

              {
              For WY:=ZY-1 To ZY+1 Do
                  For WX:=ZX-1 To ZX+1 Do
                  Begin}
                       //If Abs(BackUp[ZY,ZX]-Mid)>ThresVal Then
                       If BackUp[ZY,ZX]>Mid Then
                          CalcPic[ZY,ZX]:=255
                       Else
                          CalcPic[ZY,ZX]:=0;
                  {End;}
         End;
End;

Procedure Filter_Gauss;
Const GM : Array[0..4,0..4] Of Integer=
      (
      ( 0, 1, 2, 1, 0),
      ( 1, 3, 5, 3, 1),
      ( 2, 5,10, 5, 2),
      ( 1, 3, 5, 3, 1),
      ( 0, 1, 2, 1, 0)
      );
Var ZX,ZY : Integer;
    MX,MY : Integer;
    New   : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=3 To VRes-3 Do
         For ZX:=3 To HRes-3 Do
         Begin
              New:=0;
              For MX:=-2 To 2 Do
                  For MY:=-2 To 2 Do
                      New:=New+GM[MX+2,MY+2]*Backup[ZY+MY,ZX+MX];
              CalcPic[ZY,ZX]:=Round(0.017*New);
         End;
End;

Procedure Filter_SobelX;
Const SX : Array[0..2,0..2] Of Integer=
      (
      ( 1, 2, 1),
      ( 0, 0, 0),
      (-1,-2,-1)
      );
Var ZX,ZY : Integer;
    MX,MY : Integer;
    New1  : Integer;
    New2  : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              New1:=0;
              For MX:=-1 To 1 Do
                  For MY:=-1 To 1 Do
                      New1:=New1+BackUp[ZY+MY,ZX+MX]*SX[MY+1,MX+1];
              CalcPic[ZY,ZX]:=Max(New1);
         End;
End;

Procedure Filter_SobelY;
Const SY : Array[0..2,0..2] Of Integer=
      (
      ( 1, 0,-1),
      ( 2, 0,-2),
      ( 1, 0,-1)
      );
Var ZX,ZY : Integer;
    MX,MY : Integer;
    New1  : Integer;
    New2  : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              New1:=0;
              For MX:=-1 To 1 Do
                  For MY:=-1 To 1 Do
                      New1:=New1+BackUp[ZY+MY,ZX+MX]*SY[MY+1,MX+1];
              CalcPic[ZY,ZX]:=Max(New1);
         End;
End;

Procedure Filter_SobelMagnitude;
Const SX : Array[0..2,0..2] Of Integer=
      (
      ( 1, 2, 1),
      ( 0, 0, 0),
      (-1,-2,-1)
      );
      SY : Array[0..2,0..2] Of Integer=
      (
      ( 1, 0,-1),
      ( 2, 0,-2),
      ( 1, 0,-1)
      );
Var ZX,ZY : Integer;
    MX,MY : Integer;
    New1  : Integer;
    New2  : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              New1:=0;
              For MX:=-1 To 1 Do
                  For MY:=-1 To 1 Do
                      New1:=New1+BackUp[ZY+MY,ZX+MX]*SX[MY+1,MX+1];
              New2:=0;
              For MX:=-1 To 1 Do
                  For MY:=-1 To 1 Do
                      New2:=New2+BackUp[ZY+MY,ZX+MX]*SY[MY+1,MX+1];

              CalcPic[ZY,ZX]:=Max(Round(Sqrt(New1*New1+New2*New2)));
         End;
End;

Procedure Filter_KontrastP;
Var ZX,ZY     : Integer;
    EMax,EMin : Integer;
    CDX       : Integer;
    New       : Real;
Begin
     EMax:=0; EMin:=$FF;
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
         Begin
              If CalcPic[ZY,ZX]>EMax Then
                 EMax:=CalcPic[ZY,ZX];
              If CalcPic[ZY,ZX]<EMin Then
                 EMin:=CalcPic[ZY,ZX];
         End;

     CDX:=EMax-EMin;

     For ZY:=0 To VRes-1 Do
         For ZX:=0 To HRes-1 Do
         Begin
              New:=(255/CDX)*(CalcPic[ZY,ZX]-EMin);
              CalcPic[ZY,ZX]:=Max(Round(New));
         End;
End;

Procedure Filter_Erosion;
Const M : Array[0..2,0..2] Of Integer=
      (
      (0  ,255,  0),
      (255,255,255),
      (0  ,255,  0)
      );
Var ZX,ZY,MX,MY,New,NMin : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              New:=0;
              NMin:=$FF;
              For MX:=-1 To 1 Do
                  For MY:=-1 To 1 Do
                  Begin
                       New:=BackUp[ZY+MY,ZX+MX]-M[MY+1,MX+1]+255;
                       If New<NMin Then
                          NMin:=New;
                  End;

              CalcPic[ZY,ZX]:=NMin;
         End;
End;

Procedure Filter_Dilation;
Const M : Array[0..2,0..2] Of Integer=
      (
      (0  ,255,  0),
      (255,255,255),
      (0  ,255,  0)
      );
Var ZX,ZY,MX,MY,New,NMax : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              New:=0;
              NMax:=$00;
              For MX:=-1 To 1 Do
                  For MY:=-1 To 1 Do
                  Begin
                       New:=BackUp[ZY+MY,ZX+MX]+M[MY+1,MX+1]-255;
                       If New>NMax Then
                          NMax:=New;
                  End;

              CalcPic[ZY,ZX]:=NMax;
         End;
End;

Procedure Filter_SobelAngle;
Const SX : Array[0..2,0..2] Of Integer=
      (
      ( 1, 2, 1),
      ( 0, 0, 0),
      (-1,-2,-1)
      );
      SY : Array[0..2,0..2] Of Integer=
      (
      ( 1, 0,-1),
      ( 2, 0,-2),
      ( 1, 0,-1)
      );
Var ZX,ZY : Integer;
    MX,MY : Integer;
    New1  : Integer;
    New2  : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              New1:=0;
              For MX:=-1 To 1 Do
                  For MY:=-1 To 1 Do
                      New1:=New1+BackUp[ZY+MY,ZX+MX]*SX[MY+1,MX+1];
              New2:=0;
              For MX:=-1 To 1 Do
                  For MY:=-1 To 1 Do
                      New2:=New2+BackUp[ZY+MY,ZX+MX]*SY[MY+1,MX+1];

              If (New1=0) Or (New2=0) Then
                 CalcPic[ZY,ZX]:=0
              Else
                 CalcPic[ZY,ZX]:=Max(Round(ArcTan(New1/New2)));
         End;
End;

Procedure Filter_SemiKante;
Var T : Array[0..VRes-1,0..HRes-1] Of Byte;
    ZX,ZY : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     Move(CalcPic,T,SizeOf(CalcPic));
     Filter_SobelMagnitude;
     //Filter_ThresholdWindow;
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
             If CalcPic[ZY,ZX]>155 Then
                T[ZY,ZX]:=255;
     Move(T,CalcPic,SizeOf(CalcPic));
End;

Procedure Filter_MarrHild;
Const Mask : Array[0..10,0..10] Of Integer=
      (
      (0,0,0,-1,-1,-2,-1,-1,0,0,0),
      (0,0,-2,-4,-8,-9,-8,-4,-2,0,0),
      (0,-2,-7,-15,-22,-23,-22,-15,-7,-2,0),
      (-1,-4,-15,-24,-14,-1,-14,-24,-15,-4,-1),
      (-1,-8,-22,-14,52,103,52,-14,-22,-8,-1),
      (-2,-9,-23,-1,103,178,103,-1,-23,-9,-2),
      (-1,-8,-22,-14,52,103,52,-14,-22,-8,-1),
      (-1,-4,-15,-24,-14,-1,-14,-24,-15,-4,-1),
      (0,-2,-7,-15,-22,-23,-22,-15,-7,-2,0),
      (0,0,-2,-4,-8,-9,-8,-4,-2,0,0),
      (0,0,0,-1,-1,-2,-1,-1,0,0,0)
      );
Var ZX,ZY : Integer;
    MX,MY,New : Integer;
    T         : Array[0..VRes-1,0..HRes-1] Of Integer;
    Th        : Integer;
Begin
     Th:=10;

     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=5 To VRes-6 Do
         For ZX:=5 To HRes-6 Do
         Begin
              New:=0;
              For MX:=-5 To 5 Do
                  For MY:=-5 To 5 Do
                      New:=New+BackUp[ZY+MY,ZX+MX]*Mask[MY+5,MX+5];
              T[ZY,ZX]:=New;// Div 121;
         End;
     For ZY:=5 To VRes-6 Do
         For ZX:=5 To HRes-6 Do
         Begin
              If ((T[ZY,ZX]<-Th) And
              ((T[ZY-1,ZX]>Th) Or (T[ZY+1,ZX]>Th) Or
              (T[ZY,ZX-1]>Th) Or (T[ZY,ZX+1]>Th) Or
              (T[ZY-1,ZX-1]>Th) Or (T[ZY+1,ZX+1]>Th) Or
              (T[ZY-1,ZX+1]>Th) Or (T[ZY+1,ZX-1]>Th)))

              Or

              ((T[ZY,ZX]>Th) And
              ((T[ZY-1,ZX]<-Th) Or (T[ZY+1,ZX]<-Th) Or
              (T[ZY,ZX-1]<-Th) Or (T[ZY,ZX+1]<-Th) Or
              (T[ZY-1,ZX-1]<-Th) Or (T[ZY+1,ZX+1]<-Th) Or
              (T[ZY-1,ZX+1]<-Th) Or (T[ZY+1,ZX-1]<-Th))) Then
                  CalcPic[ZY,ZX]:=255
              Else
                  CalcPic[ZY,ZX]:=0;
         End;
End;

Procedure Filter_GaussH;
Const M : Array[0..4] Of Integer = ( 2, 5,10, 5, 2);
Var ZX,ZY,MX,New : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=2 To VRes-3 Do
         For ZX:=2 To HRes-3 Do
         Begin
              New:=0;
              For MX:=-2 To 2 Do
                  New:=New+BackUp[ZY,ZX+MX]*M[MX+2];
              CalcPic[ZY,ZX]:=New Div 24;
         End;
End;

Procedure Filter_GaussV;
Const M : Array[0..4] Of Integer = ( 2, 5,10, 5, 2);
Var ZX,ZY,MY,New : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZX:=2 To HRes-3 Do
         For ZY:=2 To VRes-3 Do
         Begin
              New:=0;
              For MY:=-2 To 2 Do
                  New:=New+BackUp[ZY+MY,ZX]*M[MY+2];
              CalcPic[ZY,ZX]:=New Div 24;
         End;
End;

Procedure Filter_Prewitt;
Const SX : Array[0..2,0..2] Of Integer=
      (
      ( 1, 1, 1),
      ( 0, 0, 0),
      (-1,-1,-1)
      );
      SY : Array[0..2,0..2] Of Integer=
      (
      ( 1, 0,-1),
      ( 1, 0,-1),
      ( 1, 0,-1)
      );
Var ZX,ZY : Integer;
    MX,MY : Integer;
    New1  : Integer;
    New2  : Integer;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=1 To VRes-2 Do
         For ZX:=1 To HRes-2 Do
         Begin
              New1:=0;
              For MX:=-1 To 1 Do
                  For MY:=-1 To 1 Do
                      New1:=New1+BackUp[ZY+MY,ZX+MX]*SX[MY+1,MX+1];
              New2:=0;
              For MX:=-1 To 1 Do
                  For MY:=-1 To 1 Do
                      New2:=New2+BackUp[ZY+MY,ZX+MX]*SY[MY+1,MX+1];

              CalcPic[ZY,ZX]:=Max(Round(Sqrt(New1*New1+New2*New2)));
         End;
End;

Procedure Filter_Hurst;
Const HM : Array[1..7,1..7] Of Integer=
      ((0,0,8,7,8,0,0),
       (0,6,5,4,5,6,0),
       (8,5,3,2,3,5,8),
       (7,4,2,1,2,4,7),
       (8,5,3,2,3,5,8),
       (0,6,5,4,5,6,0),
       (0,0,8,7,8,0,0)
       );
       LDist : Array[1..8] Of Integer=
             (0,0,16,32,37,48,51,53);
Var ZX,ZY,Rgn,MX,MY,Max,Min : Integer;
    Range                   : Array[1..8] Of Integer;
    SumRD,SumR,SumD,SumD2   : Real;
Begin
     Move(CalcPic,BackUp,SizeOf(CalcPic));
     For ZY:=4 To VRes-2 Do
         For ZX:=4 To HRes-2 Do
         Begin
              // Range fr alle 8 Regionen berechnen
              For Rgn:=1 To 8 Do
              Begin
                   Max:=0; Min:=$FFFF;
                   For MX:=-3 To 3 Do
                       For MY:=-3 To 3 Do
                           If HM[MX+4,MY+4]=Rgn Then
                           Begin
                                If BackUp[ZY+MY,ZX+MX]>Max Then
                                   Max:=BackUp[ZY+MY,ZX+MX];
                                If BackUp[ZY+MY,ZX+MX]<Min Then
                                   Min:=BackUp[ZY+MY,ZX+MX];
                           End;
                   Range[Rgn]:=1+(Max-Min);
              End;
              // Slope fr den aktuellen Pixel berechnen

              // Summe ber log(dist)*log(range)
              SumRD:=0;
              For Rgn:=1 To 8 Do
                  SumRD:=SumRD+LDist[Rgn]*Log10(Range[Rgn]);
              // Summe ber log(dist)
              SumD:=0;
              For Rgn:=1 To 8 Do
                  SumD:=SumD+LDist[Rgn];
              // Summe ber log(range)
              SumR:=0;
              For Rgn:=1 To 8 Do
                  SumR:=SumR+Log10(Range[Rgn]);

              CalcPic[ZY,ZX]:=Round((8*(SumRD-SumD*SumR))/
                                    (8));
         End;
End;

Procedure Calc(Alg : Integer);
Var Z : Integer;
Begin
     If Alg=-1 Then
        Exit;
     For Z:=1 To MainForm.Times.Value Do
     Begin
          Case Alg Of
          Blur      : Filter_Blur;
          Laplace   : Filter_Laplace;
          HExtract  : Filter_HEx;
          VExtract  : Filter_VEx;
          HAndVEx   : Filter_HVEx;
          Lighten   : Filter_Light;
          Darken    : Filter_Dark;
          MyKante   : Filter_MyKante;
          TomAlg    : Filter_TomAlg;
          GradientH : Filter_GradientH;
          GradientV : Filter_GradientV;
          GradientM : Filter_GradientM;
          ReliefH   : Filter_ReliefH;
          ReliefV   : Filter_ReliefV;
          ReliefM   : Filter_ReliefM;
          FaltenH   : Filter_FaltenH;
          FaltenV   : Filter_FaltenV;
          FaltenM   : Filter_FaltenM;
          FaltenMed1: Filter_FaltenMed1;
          FaltenMed2: Filter_FaltenMed2;
          FaltenMedM: Filter_FaltenMedM;
          Threshold : Filter_Threshold;
          FaltenAll : Filter_FaltenAllDir;
          Gauss     : Filter_Gauss;
          SobelX    : Filter_SobelX;
          SobelY    : Filter_SobelY;
          KontrastP : Filter_KontrastP;
          Erosion   : Filter_Erosion;
          Dilation  : Filter_Dilation;
          ThresWin  : Filter_ThresholdWindow;
          SobelM    : Filter_SobelMagnitude;
          SobelA    : Filter_SobelAngle;
          SemiKante : Filter_SemiKante;
          MarrHild  : Filter_MarrHild;
          GaussH    : Filter_GaussH;
          GaussV    : Filter_GaussV;
          Prewitt   : Filter_Prewitt;
          RGNGrow   : Begin End;
          Hurst     : Filter_Hurst;
          End;
          Draw_Pic(False);
     End;
     Draw_Pic(True);
End;

procedure TMainForm.FormPaint(Sender: TObject);
begin
     B.BlitIt;
end;

procedure TMainForm.LoadGfxBtnClick(Sender: TObject);
begin
     If OpenDialog1.Execute Then
     Begin
          FileName.Text:=OpenDialog1.FileName;
          Load_Grafix;
          Reset_Calc;
          FHist.Items.Clear;
          HistCount:=0;
     End;
end;

procedure TMainForm.ResetCalcBtnClick(Sender: TObject);
begin
     Reset_Calc;
end;

Procedure Add2Hist(FIdx,FTime : Integer);
Var AddLine : String;
Begin
     Inc(HistCount);
     AddLine:='#'+IntToStr(HistCount)+' '+MainForm.FilterList.Items[FIdx]+' x '+IntToStr(FTime);
     MainForm.FHist.Items.Add(AddLine);
End;

procedure TMainForm.UseFilterBtnClick(Sender: TObject);
begin
     If (GLoaded) And (FilterList.ItemIndex>-1) Then
     Begin
          Calc(FilterList.ItemIndex);
          Add2Hist(FilterList.ItemIndex,Times.Value);
     End;
end;

procedure TMainForm.FilterListClick(Sender: TObject);
begin
     Times.Value:=1;
end;

procedure TMainForm.ClearHistBtnClick(Sender: TObject);
begin
     HistCount:=0;
     FHist.Items.Clear;
end;

procedure TMainForm.HistMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     CC.Caption:=IntToStr(Y);
end;

procedure TMainForm.AddyWinClick(Sender: TObject);
begin
     If AddWin Then
     Begin
          AddForm.Close;
          AddWin:=False;
     End
     Else
     Begin
          AddForm.Show;
          AddWin:=True;
     End;
end;

end.
